window.Gleam.initSearch([{"doc":"leviathan","title":"leviathan","content":"# leviathan\n\n[![Package Version](https://img.shields.io/hexpm/v/leviathan)](https://hex.pm/packages/leviathan)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/leviathan/)\n\nA simple library that implements the State Monad in Gleam!\n\n![Leviathan](./thumbnail.png)\n\n## Example\n\n```gleam\nimport leviathan as lv\n\nfn tick() -&gt; lv.State(s, Nil) {\n  use x &lt;- lv.do(lv.get())\n  lv.put(x + 1)\n}\n```\n\n## Installation\n\nTo add this library as a dependency to a gleam project run the following command:\n\n```sh\ngleam add leviathan\n```\n\n## Documentation\n\nThe auto-generated documentation can be founded [here](https://hexdocs.pm/leviathan)\n","url":"index.html"},{"doc":"leviathan","title":"State","content":"pub type State(s, a) {\n  State(run: fn(s) -&gt; #(a, s))\n}\n State monad\nState(run: fn(s) -&gt; #(a, s))\n\n\nSynonyms:\nleviathan.State\nleviathan State","url":"leviathan.html#State"},{"doc":"leviathan","title":"do","content":"pub fn do(\n  st: State(a, b),\n  f: fn(b) -&gt; State(a, c),\n) -&gt; State(a, c)\n Monadic bind (&gt;&gt;=) that allows you to use gleam&#39;s `use` syntax as a replacement for `do` notation\nSynonyms:\nleviathan.do\nleviathan do","url":"leviathan.html#do"},{"doc":"leviathan","title":"eval","content":"pub fn eval(st: State(a, b), initial: a) -&gt; b\n Apply a state function `st` to an initial state and just return the computation&#39;s result\nSynonyms:\nleviathan.eval\nleviathan eval","url":"leviathan.html#eval"},{"doc":"leviathan","title":"exec","content":"pub fn exec(st: State(a, b), with initial: a) -&gt; a\n Apply a state function `st` to an initial state and return the final state\nSynonyms:\nleviathan.exec\nleviathan exec","url":"leviathan.html#exec"},{"doc":"leviathan","title":"get","content":"pub fn get() -&gt; State(a, a)\n Sets the resulting value to the current state\nSynonyms:\nleviathan.get\nleviathan get","url":"leviathan.html#get"},{"doc":"leviathan","title":"go","content":"pub fn go(st: State(a, b), initial: a) -&gt; #(b, a)\n Apply a state function `st` to an initial state and return a pair of a value and the final state\nSynonyms:\nleviathan.go\nleviathan go","url":"leviathan.html#go"},{"doc":"leviathan","title":"map","content":"pub fn map(st: State(a, b), f: fn(b) -&gt; c) -&gt; State(a, c)\n Apply the function `f` to the resulting value of `s`\nSynonyms:\nleviathan.map\nleviathan map","url":"leviathan.html#map"},{"doc":"leviathan","title":"modify","content":"pub fn modify(f: fn(a) -&gt; a) -&gt; State(a, Nil)\n Apply the function `f` to the current state\n Replaces the return value with Nil\nSynonyms:\nleviathan.modify\nleviathan modify","url":"leviathan.html#modify"},{"doc":"leviathan","title":"put","content":"pub fn put(x: a) -&gt; State(a, Nil)\n Sets the state value to a given state `x`\n Replaces the return value with Nil\nSynonyms:\nleviathan.put\nleviathan put","url":"leviathan.html#put"},{"doc":"leviathan","title":"return","content":"pub fn return(x: a) -&gt; State(b, a)\n Monadic return that allows you to use gleam&#39;s `use` syntax as a replacement for `do` notation\n Check `do` for examples\nSynonyms:\nleviathan.return\nleviathan return","url":"leviathan.html#return"},{"doc":"leviathan","title":"leviathan","content":"","url":"leviathan.html"}]);